<?php 
namespace Concrete\Package\VividLocations\Block\VividLocationsMap;
use \Concrete\Core\Block\BlockController;
use Database;
use Page;
use Core;

defined('C5_EXECUTE') or die(_("Access Denied.")); 
class Controller extends BlockController
{
		
	protected $btTable = 'btLocationsMap';
    protected $btInterfaceWidth = "400";
    protected $btWrapperClass = 'ccm-ui';
    protected $btInterfaceHeight = "365";
    protected $btDefaultSet = 'multimedia';

    public function getBlockTypeDescription()
    {
        return t("Add Locations Map to the page");
    }

    public function getBlockTypeName()
    {
        return t("Location Map");
    }
    public function getLocation($lID)
    {
        $db = Database::get(); 
        $location = $db->GetRow("SELECT * FROM VividLocations WHERE lID=?",$lID);
        return $location;
    }
	public function getLocations()
	{
        $db = Database::get(); 
        $locations = $db->GetAll("SELECT * FROM VividLocations");
        $this->set("locations",$locations);
    }
    public function getSelectedLocations()
    {
        $db = Database::get(); 
        $selectedLocations = $db->GetAll('SELECT * from btLocationsMapItem WHERE bID = ?', array($this->bID));
        $selectedLIDs = array();
        foreach($selectedLocations as $sl){
            $selectedLIDs[] = $sl['lID'];
        }
        $this->set('selectedLocations',$selectedLocations);
        $this->set('selectedLIDs', $selectedLIDs);
        return $selectedLIDs;
    }
    public function add()
    {
        $this->getLocations();
        $this->getSelectedLocations();
    }
    public function edit()
    {
        $this->getLocations();
        $this->getSelectedLocations();
    }
    public function validate($args)
    {
        $e = Core::make('helper/validation/error');
        $lIDs = $this->post('lID');
        if (count($lIDs) == 0) {
            $e->add(t('You must choose at least one location.'));
        }
        if(!ctype_digit(trim($args['mapheight']))){
            $e->add(t("Map Height must be solely numeric"));
        }
        return $e;
    }
    public function save($args)
    {
        $db = Database::get(); 
        $db->Execute('DELETE from btLocationsMapItem WHERE bID = ?', array($this->bID));
        $count = count($args['lID']);
        parent::save($args);
        for ($i=0; $i<$count;$i++) 
        {
            $vals = array($this->bID,$args['lID'][$i]);
            $db->Execute('INSERT INTO btLocationsMapItem (bID, lID) values(?,?)',$vals);
        }
    }
    public function view()
    {
        $selectedLIDs = $this->getSelectedLocations();
        $locations = array();
        foreach($selectedLIDs as $lID){
            $location = $this->getLocation($lID);
            if(!empty($location['geolat']) && !empty($location['geolong'])){  
                $locations[] = $location;
            }
        }
        $this->set('locations',$locations);
        
    }
    public function registerViewAssets()
    {
        $this->requireAsset('javascript', 'jquery');
        $this->addFooterItem('<script type="text/javascript" src="//maps.google.com/maps/api/js?sensor=false"></script>',$this->bID);
    }
	
}
	
?>